// ServerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "afxctl.h"
#include <string>

#include "Server.h"
#include "ServerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

const int ID_TIMER1 = 100;
CServerDlg* gDialog = NULL;

using namespace std;

BEGIN_DISPATCH_MAP(CIpServerEventSink, CCmdTarget)
//{{AFX_DISPATCH_MAP(CIpServerEventSink)
	DISP_FUNCTION_ID(CIpServerEventSink, "OnClientConnect", 203, OnClientConnect, VT_EMPTY, VTS_I4)
	DISP_FUNCTION_ID(CIpServerEventSink, "OnClientDisconnect", 204, OnClientDisconnect, VT_EMPTY, VTS_I4)
//}}AFX_DISPATCH_MAP
END_DISPATCH_MAP()

BEGIN_INTERFACE_MAP(CIpServerEventSink, CCmdTarget)
	INTERFACE_PART(CIpServerEventSink, IID_IIpServerEventSink, Dispatch)
END_INTERFACE_MAP()

CIpServerEventSink::CIpServerEventSink()
{
	EnableAutomation();
}

void CIpServerEventSink::OnClientConnect(long ConnId)
{
   // use IpServer.GetClientParam to retreive client params

	HWND pWnd = GetDlgItem(m_DialogHWND, IDC_EDIT4);
	LockWindowUpdate(pWnd);

	long len = GetWindowTextLength(pWnd);
	char* buffer = new char[len + 1];
	GetWindowText(pWnd, buffer, len + 1);

	string msg(string(buffer) + "listener connected\r\n");

	BOOL res = SetWindowText(pWnd, msg.c_str());

	delete [] buffer;
	LockWindowUpdate(NULL);
	(gDialog->m_Log).SetSel(msg.length(), msg.length(), FALSE);
	(gDialog->m_Log).RedrawWindow();
}

void CIpServerEventSink::OnClientDisconnect(long ConnId)
{
   // use IpServer.GetClientParam to retreive client params

	HWND pWnd = GetDlgItem(m_DialogHWND, IDC_EDIT4);
	LockWindowUpdate(pWnd);

	long len = GetWindowTextLength(pWnd);
	char* buffer = new char[len + 1];
	GetWindowText(pWnd, buffer, len + 1);

	string msg(string(buffer) + "listener disconnected\r\n");

	BOOL res = SetWindowText(pWnd, msg.c_str());

	delete [] buffer;
	LockWindowUpdate(NULL);
	(gDialog->m_Log).SetSel(msg.length(), msg.length(), FALSE);
	(gDialog->m_Log).RedrawWindow();
}

/////////////////////////////////////////////////////////////////////////////
// CServerDlg dialog

CServerDlg::CServerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CServerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CServerDlg)
	m_SpeakerPortStr = _T("");
	m_ListenerPortStr = _T("");
	m_NumClients = _T("");
	m_SpeakerStatus = _T("");
	m_ListenerStatus = _T("");
	m_BytesReceived = _T("");
	m_BytesSent = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CServerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CServerDlg)
	DDX_Control(pDX, IDC_EDIT4, m_Log);
	DDX_Control(pDX, IDC_COMBO2, m_ListenerProto);
	DDX_Control(pDX, IDC_COMBO1, m_SpeakerProto);
	DDX_Control(pDX, IDC_BUTTON2, m_StopServer);
	DDX_Control(pDX, IDC_BUTTON1, m_StartServer);
	DDX_Text(pDX, IDC_EDIT1, m_SpeakerPortStr);
	DDX_Text(pDX, IDC_EDIT2, m_ListenerPortStr);
	DDX_Text(pDX, IDC_EDIT3, m_NumClients);
	DDX_Text(pDX, IDC_STATIC1, m_SpeakerStatus);
	DDX_Text(pDX, IDC_STATIC2, m_ListenerStatus);
	DDX_Text(pDX, IDC_STATIC3, m_BytesReceived);
	DDX_Text(pDX, IDC_STATIC4, m_BytesSent);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CServerDlg, CDialog)
	//{{AFX_MSG_MAP(CServerDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_WM_CLOSE()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CServerDlg message handlers

BOOL CServerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	gDialog = this;

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_SpeakerProto.SetCurSel(1);
	m_ListenerProto.SetCurSel(1);

	m_SpeakerPortStr = _T("17860");
	m_ListenerPortStr = _T("17861");

	UpdateData(FALSE);

	VCInit();
	SetTimer(ID_TIMER1, 500, NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CServerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CServerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CServerDlg::VCInit()
{
	m_serverSpeak.CreateInstanceLic(__uuidof(vcproIpServerX), L"0");
	m_serverListen.CreateInstanceLic(__uuidof(vcproIpServerX), L"0");

	m_serverListen->MaxClients = 3;

	SetLink(m_serverSpeak, m_serverListen);

	m_ServerSink.m_DialogHWND = m_hWnd;
	m_pUnkSink = m_ServerSink.GetIDispatch(FALSE);
	BOOL res = AfxConnectionAdvise(m_serverListen, IID_IIpServerEventSink, m_pUnkSink, FALSE,
		&m_dwCookie);
}

void CServerDlg::VCUninit()
{
	AfxConnectionUnadvise(m_serverListen, IID_IIpServerEventSink, m_pUnkSink, FALSE,
		m_dwCookie);
	m_serverSpeak->Active = false;
}

void CServerDlg::SetLink(IvcproProviderPtr provider, IvcproConsumerPtr consumer)
{
	provider->AddConsumer(consumer);
}

void CServerDlg::OnButton1()
{
	BSTR port;

	UpdateData();

	m_serverSpeak->Proto = static_cast<unaProtoType>(m_SpeakerProto.GetCurSel());
	port = m_SpeakerPortStr.AllocSysString();
	m_serverSpeak->Port = port;
	SysFreeString(port);

	m_serverListen->Proto = static_cast<unaProtoType>(m_ListenerProto.GetCurSel());
	port = m_ListenerPortStr.AllocSysString();
	m_serverListen->Port = port;
	SysFreeString(port);

	m_serverSpeak->Active = true;
}

void CServerDlg::OnButton2() { m_serverSpeak->Active = false; }

void CServerDlg::OnClose() 
{
	KillTimer(ID_TIMER1);
	VCUninit();
	CDialog::OnClose();
}

void CServerDlg::OnTimer(UINT nIDEvent) 
{
	CWnd* pWnd;

	bool enabled = !m_serverSpeak->Active || !m_serverListen->Active;
	m_StartServer.EnableWindow(enabled);
   m_StopServer.EnableWindow(!enabled);

	string strSpeakerStatus = m_serverSpeak->Active ? "active" : "not active";
	string strListenerStatus = m_serverListen->Active ? "active" : "not active";

	char buffer[10];
	itoa(m_serverSpeak->BytesReceived, buffer, 10);
	string strBytesReceived(string("bytes received: ") + string(buffer));
	itoa(m_serverListen->BytesSent, buffer, 10);
	string strBytesSent(string("bytes sent: ") + string(buffer));
	itoa(m_serverListen->ClientCount, buffer, 10);
	string strNumClients(buffer);

	pWnd = GetDlgItem(IDC_STATIC1);
	pWnd->SetWindowText(strSpeakerStatus.c_str());
	pWnd = GetDlgItem(IDC_STATIC2);
	pWnd->SetWindowText(strListenerStatus.c_str());
	pWnd = GetDlgItem(IDC_STATIC3);
	pWnd->SetWindowText(strBytesReceived.c_str());
	pWnd = GetDlgItem(IDC_STATIC4);
	pWnd->SetWindowText(strBytesSent.c_str());
	pWnd = GetDlgItem(IDC_EDIT3);
	pWnd->SetWindowText(strNumClients.c_str());

	CDialog::OnTimer(nIDEvent);
}
